unit SSDetect;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Memo1: TMemo;
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function LastInput: DWord;
var
  LInput: TLastInputInfo;
begin
  LInput.cbSize := SizeOf(TLastInputInfo);
  GetLastInputInfo(LInput);
  Result := GetTickCount - LInput.dwTime;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  fSSEnable, fSSRunning : LongBool;
begin
  Memo1.Lines.Add('----------------');
  Memo1.Lines.Add( Format('System Idle since %d ms', [LastInput]) );

  // Get screen server enabled
  if not SystemParametersInfo(spi_GetScreenSaveActive, 0, @fSSEnable, 0) then begin
    Memo1.Lines.Add('Error get spi_GetScreenSaveActive');
//    Timer1.Enabled := false;
    exit;
  end;

  {if not fSSEnable then begin
    Timer1.Enabled := false;
    exit;
  end;}

  // Get screenserver run
  if not SystemParametersInfo(SPI_GETSCREENSAVERRUNNING, 0, @fSSRunning, 0) then begin
    Memo1.Lines.Add('Error get SPI_GETSCREENSAVERRUNNING');
    Timer1.Enabled := false;
    exit;
  end;

  Memo1.Lines.Add('SPI_GETSCREENSAVERRUNNING = '+BoolToStr(fSSRunning, true));
  if fSSRunning then
    MessageBeep(0);
end;

end.
